package cmdVM

import (
    "nexus-client/exec"
    u "nexus-client/utils"
)

type AttachAsync struct {
    Name string
}

func (cmd *AttachAsync)GetName() string {
    return cmd.Name
}

func (cmd *AttachAsync)GetDesc() []string {
    return []string{
        "Attaches to one or more VMs in order to use their desktop environment.",
        "If not the VM's owner: requires VM_ATTACH VM access capability or VM_ATTACH_ANY user capability."}
}

func (cmd *AttachAsync)PrintUsage() {
    printRegexUsage(cmd)
    printRegexUsageDetails()
}

func (cmd *AttachAsync)Run(args []string) int {
    if err := exec.CheckRemoteViewer(); err != nil {
        u.PrintlnErr(err.Error())
        return 1
    }

    argc := len(args)
    if argc < 1 {
        cmd.PrintUsage()
        return 1
    }

    creds, err := getFilteredVMCredentials("/vms/attach", args)
    if err != nil {
        u.PrintlnErr(err.Error())
        return 1
    }

    if len(creds) == 0 {
        u.PrintlnErr("Error: VM(s) not found.")
        return 1
    }

	statusCode, err := AttachToVMs(creds, false)
	if err != nil {
		u.PrintlnErr(err)
	}

    return statusCode
}
